package afterburner.command.config
{

	import afterburner.command.game.StartGame;
	import afterburner.command.game.StopGame;
	import afterburner.command.remote.AddAndGetScore;
	import afterburner.command.remote.GetScore;
	import afterburner.command.sound.SoundPlay;
	import afterburner.event.EventList;
	import afterburner.model.AppliModel;
	import afterburner.model.CollisionModel;
	import afterburner.model.SoundModel;
	import afterburner.view.game.FPSView;
	import afterburner.view.game.InterfaceView;
	import afterburner.view.game.Stage3DView;
	import afterburner.view.game.stage3D.Avion;
	import afterburner.view.game.stage3D.Background;
	import afterburner.view.game.stage3D.Cloud;
	import afterburner.view.game.stage3D.EnnemisManager;
	import afterburner.view.game.stage3D.ExplosionManager;
	import afterburner.view.game.stage3D.Interface3D;
	import afterburner.view.game.stage3D.RocketManager;
	import flash.display.DisplayObjectContainer;
	import flash.display.Sprite;
	import flash.events.ContextMenuEvent;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import net.pixlib.commands.PXAbstractCommand;
	import net.pixlib.commands.PXDelegate;
	import net.pixlib.quick.PXQuick;
	import net.pixlib.utils.PXDisplayUtils;
	
	
	
	


	public class BuildMVC extends PXAbstractCommand
	{
		private var _menu : ContextMenu;

		public function BuildMVC()
		{
		}

		override protected function onExecute(event : Event = null) : void
		{
			/** les commandes */
			PXQuick.controller.pushCommandClass(EventList.onSoundPlay, SoundPlay);
			PXQuick.controller.pushCommandClass(EventList.onStartGame, StartGame);
			PXQuick.controller.pushCommandClass(EventList.onStopGame, StopGame);
			
			
			/*création des vues */
			
			var uiMaster : Sprite = PXDisplayUtils.createSprite(PXQuick.root);
			
			var oStage3DView : Stage3DView = new Stage3DView(PXQuick.plugin, uiMaster);
			var oInterfaceView : InterfaceView = new InterfaceView(PXQuick.plugin, uiMaster);
			var oFPSView : FPSView = new FPSView(PXQuick.plugin, uiMaster);
			
			/** amf 
			/** getVideoEVENT used through Sequencer
			controller.pushCommandClass(EventList.getVideoEVENT, GetVideo); */
			PXQuick.controller.pushCommandClass(EventList.getScoreEvent, GetScore);
			PXQuick.controller.pushCommandClass(EventList.addNewScoreEvent, AddAndGetScore);

			
			
			/* vues Stage3D */
			var uiMaster3D : Sprite = PXDisplayUtils.createSprite(uiMaster);
			
			// vues
			var oBackground:Background = new Background(PXQuick.plugin, uiMaster3D);
			var oAvion:Avion = new Avion(PXQuick.plugin, uiMaster3D);
			var oCloud:Cloud = new Cloud(PXQuick.plugin, uiMaster3D);
			var oInterface:Interface3D = new Interface3D(PXQuick.plugin, uiMaster3D);
			
			// création des managers
			var oEnnemisManager:EnnemisManager = new EnnemisManager(PXQuick.plugin, uiMaster3D);
			var oRocketManager:RocketManager = new RocketManager(PXQuick.plugin, uiMaster3D);
			var oExplosionManager:ExplosionManager = new ExplosionManager(PXQuick.plugin, uiMaster3D);
			
			
			/* création des modèles */
			
			var model_mc : DisplayObjectContainer = PXDisplayUtils.createSprite(PXQuick.root);
			
			// PXBasePlugin
			/*logger.debug("plugin: " + owner, this);
			logger.debug("plugin: " + PXQuick.plugin, this);*/

			var model : AppliModel = new AppliModel(PXQuick.plugin, model_mc);
			model.addListener(oStage3DView);
			model.addListener(oInterfaceView);
			model.addListener(oFPSView);
			
			
			var modelSound : SoundModel = new SoundModel();

			var oCollision : CollisionModel = new CollisionModel(PXQuick.plugin, model_mc);
			oCollision.addListener(oEnnemisManager);
			oCollision.addListener(oRocketManager);
			oCollision.addListener(oExplosionManager);
			oCollision.addListener(oInterface);
			oCollision.addListener(oAvion);
			
	
			/* personnalisation du menu contextuel */
			
			_menu = new ContextMenu();
			_menu.hideBuiltInItems();
			// _menu.addEventListener(ContextMenuEvent.MENU_SELECT, _onSelectHandler);
			_register("Made with AS3 Formation", "http://www.formation-actionscript.com");
			_register("Copyright AS3 Facile", "http://www.actionscript-facile.com");
			PXQuick.root.contextMenu = _menu;
			_menu = null;

			fireCommandEndEvent();
		}



		/**
		 * Créer un élément du menu contextuel.
		 * 
		 */
		private function _register(label : String, url : String) : void
		{
			var item : ContextMenuItem = new ContextMenuItem(label);
			item.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, PXDelegate.create(_onItemSelectedHandler, url));

			_menu.customItems.push(item);
		}

		
		
		/**
		 * Affiche l'url du menu contextuel.
		 * 
		 */
		private function _onItemSelectedHandler(event : Event, url : String) : void
		{
			navigateToURL(new URLRequest(url), "_blank");
		}
	}
}
