/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.engine.elements
{
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.textures.Texture;	
	

	/**
	 * Gestion des caractéristiques d'une balle.
	 * 
	 */
	public class Lazer	
	{
		private var oMovie:MovieClip = null;
				
		/**
		 * Constructeur.
		 * Ajoute un ennemi positionné aléatoirement.
		 * 
		 */
		public function Lazer(frames:Vector.<Texture>, name:String, x:Number = 0, y:Number = 0)
		{
			this.init(frames, name, x , y);
		}
		
		
		/**
		 * Init de la création de l'ennemi.
		 * 
		 */
		private function init(frames:Vector.<Texture>, name:String, x:Number = 0, y:Number = 0) : void
		{			
			oMovie = new MovieClip(frames, 60);
			oMovie.name = name;
			Starling.juggler.add ( oMovie );
			
			oMovie.x = x;
			oMovie.y = y;
		}
		

		/**
		 * Renvoie le clip pour ajout sur la scène
		 */
		public function get clip() : MovieClip {return oMovie;}
		
		
		
		/**
		 * Mise à jour du mouvement de l'ennemis.
		 * 
		 */
		public function update() : void
		{
			if( oMovie == null )	return;
			
			oMovie.y -= 20;
		}

		
		/**
		 * Supprime les ressources graphiques utilisées par l'ennemis.
		 * 
		 */
		private function remove() : void
		{
			if( oMovie != null )
			{
				Starling.juggler.remove ( oMovie );
				oMovie.removeFromParent(true);
				oMovie = null; 
			}
			
		}


		/**
		 * Supprime les ressources utilisées par l'ennemis.
		 * 
		 */
		public function dispose() : void
		{
			this.remove();
		}
		
	}
}