/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package afterburner.view.game.engine.elements
{
	
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.textures.Texture;	


	/**
	 * Gestion des caractéristiques d'une balle.
	 * 
	 */
	public class Smoke
	{
		private var oMovie : MovieClip = null;
		private var rotationSpeed : Number;
		private var nSpeed:Number;		
					
				
		/**
		 * Constructeur.
		 * Ajoute un ennemi positionné aléatoirement.
		 * 
		 */
		public function Smoke(frames:Vector.<Texture>, x:Number = 0, y:Number = 0)
		{
			this.init(frames, x , y);
		}
		
		
		/**
		 * Init de la création de l'ennemi.
		 * 
		 */
		private function init(frames:Vector.<Texture>, x:Number = 0, y:Number = 0) : void
		{
			/* init de l'ennemis */
			oMovie = new MovieClip(frames, 60);
			Starling.juggler.add ( oMovie );
			
			oMovie.x = x;
			oMovie.y = y;
			
			oMovie.scaleX = oMovie.scaleY = 0.2;
			oMovie.alpha = 0.8;
			rotationSpeed = Math.random() * 0.2 - 0.1;
			nSpeed = Math.random() * 20 - 10;
		}


		/**
		 * Renvoie le clip pour ajout sur la scène
		 */
		public function get clip() : MovieClip {return oMovie;}
		
		
		
		/**
		 * Mise à jour du mouvement de l'ennemis.
		 * 
		 */
		public function update(x:Number = 0, y:Number = 0) : void
		{
			if( oMovie.visible == false )	return;
			
			oMovie.x = x+nSpeed;
			oMovie.y = y+nSpeed;
			
			oMovie.rotation += rotationSpeed;
			oMovie.scaleX = oMovie.scaleY += 0.04;
			oMovie.alpha -= 0.03;
			
			if(oMovie.alpha <  0.1)
				oMovie.visible = false;// hide partical !	
		}

		
		/**
		 * Supprime les ressources graphiques utilisées par l'ennemis.
		 * 
		 */
		private function remove() : void
		{
			if( oMovie != null )
			{
				Starling.juggler.remove ( oMovie );
				oMovie.removeFromParent(true);
				oMovie = null; 
			}
			
		}


		/**
		 * Supprime les ressources utilisées par l'ennemis.
		 * 
		 */
		public function dispose() : void
		{
			this.remove();
		}
		
	}
}